package betterquesting.commands.admin;

import betterquesting.api.questing.IQuest;
import betterquesting.api.questing.IQuestLine;
import betterquesting.api.questing.IQuestLineEntry;
import betterquesting.api2.storage.DBEntry;
import betterquesting.commands.QuestCommandBase;
import betterquesting.network.handlers.NetQuestEdit;
import betterquesting.questing.QuestDatabase;
import betterquesting.questing.QuestLineDatabase;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.TreeSet;
import net.minecraft.command.CommandBase;
import net.minecraft.command.ICommandSender;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.ChatComponentTranslation;

/* loaded from: betterquesting_commands_admin.jar:betterquesting/commands/admin/QuestCommandPurge.class */
public class QuestCommandPurge extends QuestCommandBase {
    public String getCommand() {
        return "purge_hidden_quests";
    }

    public void runCommand(MinecraftServer server, CommandBase command, ICommandSender sender, String[] args) {
        TreeSet<Integer> knownKeys = new TreeSet<>();
        Iterator it = QuestLineDatabase.INSTANCE.getEntries().iterator();
        while (it.hasNext()) {
            for (DBEntry<IQuestLineEntry> qle : ((IQuestLine) ((DBEntry) it.next()).getValue()).getEntries()) {
                knownKeys.add(Integer.valueOf(qle.getID()));
            }
        }
        Iterator<Integer> keyIterator = knownKeys.iterator();
        List<Integer> removeQueue = new ArrayList<>();
        int n = -1;
        for (DBEntry<IQuest> entry : QuestDatabase.INSTANCE.getEntries()) {
            while (n < entry.getID() && keyIterator.hasNext()) {
                n = keyIterator.next().intValue();
            }
            if (n != entry.getID()) {
                removeQueue.add(Integer.valueOf(entry.getID()));
            }
        }
        int removed = removeQueue.size();
        int[] bulkIDs = new int[removeQueue.size()];
        for (int n2 = 0; n2 < bulkIDs.length; n2++) {
            bulkIDs[n2] = removeQueue.get(n2).intValue();
        }
        NetQuestEdit.deleteQuests(bulkIDs);
        sender.func_145747_a(new ChatComponentTranslation("betterquesting.cmd.purge_hidden", new Object[]{Integer.valueOf(removed)}));
    }
}
